import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import hilfsklassen.Bilder;

import bauteile.*;
import konstanten.Style;

public class Rasterlayout extends Canvas
{
     private int AKTUELLE_AUSWAHL = 0;

     private Image rasterbild = null;

     private Widerstand r1,r2,r3;
     private Bruecke b1,b2;

     private ArrayList<BauteilInterface> bauteile = new ArrayList<BauteilInterface>();

     private ArrayList<BauteilInterface> auswahl = new ArrayList<BauteilInterface>();

     public Rasterlayout()
     {
         rasterbild = Bilder.holeBild("raster.png");

         JFrame frame = new JFrame();

         frame.addKeyListener(new TastenLauscher());

         frame.setBounds(10,10,900,700);
         frame.getContentPane().add(this);
         frame.setVisible(true); 

         auswahl.add(new Widerstand());
         auswahl.add(new Widerstand());
         auswahl.add(new Widerstand());
         auswahl.add(new Widerstand());

         auswahl.add(new Bruecke());
         auswahl.add(new Bruecke());
         auswahl.add(new Bruecke());
         auswahl.add(new Bruecke());

         for(int i=0;i<4;i++)
         {
             auswahl.get(i+0).setTranslation(Style.XRASTER_AUSWAHLBEREICH,
                                             Style.YRASTER_AUSWAHLBEREICH);         
             auswahl.get(i+4).setTranslation(Style.XRASTER_AUSWAHLBEREICH,
                                             Style.YRASTER_AUSWAHLBEREICH);         
             auswahl.get(i+0).setRotation(i); 
             auswahl.get(i+4).setRotation(i); 
         }




         bauteile.add(new Widerstand());
         bauteile.add(new Widerstand());
         bauteile.add(new Widerstand());

         bauteile.add(new Bruecke());
         bauteile.add(new Bruecke());

         bauteile.get(0).setTranslation(8,1);         
         bauteile.get(0).setRotation(0); 

//Hierzu muss Interface gendert werden !!!:        
         bauteile.get(0).setBeschriftung("100");

         bauteile.get(1).setTranslation(16,1);         
         bauteile.get(1).setRotation(0);         

         bauteile.get(2).setTranslation(16,1);         
         bauteile.get(2).setRotation(1);         
         bauteile.get(2).setBeschriftung("2k2");

         bauteile.get(3).setTranslation(0,0);         
         bauteile.get(3).setRotation(0);         

         bauteile.get(4).setTranslation(0,0);         
         bauteile.get(4).setRotation(1);         

         bauteile.add(bauteile.get(4).clone());
         bauteile.get(5).setTranslation(2,0);
     }

     public void paint(Graphics g)
     {         
         if(rasterbild!=null)
         {
             g.drawImage(rasterbild,0,0,Color.WHITE,this); 
         }

         Graphics2D g2d = (Graphics2D)g;

         for(int i=0;i<bauteile.size();i++)
                 bauteile.get(i).zeichnen(g2d);

         //Aktuell ausgewaehltes Bauteil anzeigen:
         auswahl.get(AKTUELLE_AUSWAHL).zeichnen(g2d);
     }

     public static void main(String[] args)
     {
         Rasterlayout rasterlayout = new Rasterlayout();
     }

    //Auf Sondertasten reagieren ber KeyListener
    private class TastenLauscher implements KeyListener
    {
        public void keyPressed(KeyEvent e) 
        {
            int c = e.getKeyCode();

            if(c == KeyEvent.VK_ESCAPE  )
            {
                System.out.println("Taste ESC gedrueckt.");
                AKTUELLE_AUSWAHL++;
                AKTUELLE_AUSWAHL%=auswahl.size();
                repaint();
            }

            if(c == KeyEvent.VK_ENTER   )
            {
                bauteile.add(auswahl.get(AKTUELLE_AUSWAHL).clone());
                bauteile.get(bauteile.size()-1).setTranslation(Style.XRASTER_ZIELBEREICH,
                                                               Style.YRASTER_ZIELBEREICH);
                repaint();
            } 

            if(c == KeyEvent.VK_RIGHT   )
            {
                int x = 1  +  bauteile.get(bauteile.size()-1).getX();
                int y = 0  +  bauteile.get(bauteile.size()-1).getY();
                bauteile.get(bauteile.size()-1).setTranslation(x,y);
                repaint();
            } 
            if(c == KeyEvent.VK_LEFT   )
            {
                int x = -1  +  bauteile.get(bauteile.size()-1).getX();
                int y = 0  +  bauteile.get(bauteile.size()-1).getY();
                bauteile.get(bauteile.size()-1).setTranslation(x,y);
                repaint();
            } 
            if(c == KeyEvent.VK_UP   )
            {
                int x = 0  +  bauteile.get(bauteile.size()-1).getX();
                int y = -1  +  bauteile.get(bauteile.size()-1).getY();
                bauteile.get(bauteile.size()-1).setTranslation(x,y);
                repaint();
            } 
            if(c == KeyEvent.VK_DOWN   )
            {
                int x = 0  +  bauteile.get(bauteile.size()-1).getX();
                int y = 1  +  bauteile.get(bauteile.size()-1).getY();
                bauteile.get(bauteile.size()-1).setTranslation(x,y);
                repaint();
            } 
        }
        public void keyReleased(KeyEvent e)
        {
        }
        public void keyTyped(KeyEvent e) 
        {
        }
    }
}